#!/bin/sh

clear

CNF=./ca.cnf

echo -e "Dieses Script erstellt im aktuellen Verzeichnis\neine Zertifizierungsstelle (CA) und generiert ein Root-Zertifikat"
echo -e "\nACHTUNG: eine vorhandene CA wird ueberschrieben und zurueckgesetzt!\nBereits erstellte Zertifikate muessen dann ersetzt werden!!!"
echo -e "\nDruecken Sie 'Enter' zum Fortfahren oder STRG + C zum Abbrechen"; read

echo "...erstelle die notwendigen Verzeichnisse"
sleep 2
mkdir -p newcerts
mkdir -p crls
mkdir -p p12
mkdir -p -m700 private

echo -e "\n...erstelle eine leere Datenbank"
sleep 2
cp /dev/null index.txt

echo -e "\n...initialisiere die Dateien fuer die Seriennummern"
sleep 2
echo -ne "01" > serial
echo -ne "01" > crlnumber

echo -e "\n...generiere einen 2048 Bit privaten Schluessel fuer die CA"
echo "   Sie werden gleich zur Eingabe eines Passwortes aufgefordert"
echo -e "\n   Druecken Sie 'Enter' zum Fortfahren"; read
openssl genrsa -des3 -out private/ca.key 2048

echo -e "\n...erstelle ein Root-Zertifikat"
echo -e "\n   Wieviel Tage soll das Zertifikat gueltig sein? \c"; read DAYS
echo -e "\n   Sie werden nun zur Eingabe des vorher gesetzten Passwortes aufgefordert"
echo -e "\n   Druecken Sie 'Enter' zum Fortfahren"; read
openssl req -config $CNF -new -x509 -days $DAYS -key private/ca.key -out ca.crt

echo -e "\n...erstelle den Diffie-Hellman-Parameter"
sleep 2
openssl dhparam -out dh1024.pem 1024

echo "\n\n...ihr Root-Zertifikat (bzw. Stammzertifikat)"
sleep 2
openssl x509 -in ca.crt -noout -text
