#!/bin/sh

clear

ZERTNAME=${1}
CNF=./ca.cnf

if [ "$1" != "" ]; then
    echo -e "Dieses Skript sperrt das Zertifikat $ZERTNAME und\nerstellt eine neue Certificate Revocation List (CRL)"
    echo -e "\nDruecken Sie 'Enter' zum Fortfahren oder STRG + C zum Abbrechen"; read

    openssl ca -revoke certs/$ZERTNAME

else
    echo -e "Dieses Skript erstellt eine neue Certificate Revocation List (CRL)"
    echo -e "\nDruecken Sie 'Enter' zum Fortfahren oder STRG + C zum Abbrechen"; read

fi

echo -e "\n...generiere die CRL"
echo -e "   Halten Sie das Passwort des Root-Zertifikates bereit"
echo -e "\n   Druecken Sie 'Enter' zum Fortfahren"; read
openssl ca -config $CNF -gencrl -out crls/crl.pem

echo -e "\n...Ausgabe der aktuellen CRL"
sleep 2
openssl crl -in crls/crl.pem -noout -text
