#!/bin/sh

# make_cert.sh NAME

clear

ZERTNAME=${1}
CNF=./ca.cnf

if [ "$ZERTNAME" == "" ]; then
  echo -e "Sie muessen einen Namen uebergeben!"
  echo -e "\n    make_cert.sh NAME\n"
  
  exit 1
fi

echo -e "Dieses Skript erstellt ein Zertifikat fuer $ZERTNAME"
echo -e "\nDruecken Sie 'Enter' zum Fortfahren oder STRG + C zum Abbrechen"; read

echo -e "\n...erstelle zuerst einen 1024 Bit Schluessel in private/${ZERTNAME}.key"
sleep 2
#openssl genrsa -des3 -out private/${ZERTNAME}.key 1024
openssl genrsa -out private/${ZERTNAME}.key 1024

echo -e "\n...stelle nun eine Zertifikatsanfrage"
sleep 2
openssl req -config $CNF -new -key private/${ZERTNAME}.key -out ${ZERTNAME}.req 

# Anfrage ausgeben
openssl req -config $CNF -in ${ZERTNAME}.req -noout -text

echo -e "\nDruecken Sie 'Enter' zum Fortfahren"; read

echo -e "\n...generiere ein Zertifikat mit dem Namen: ${ZERTNAME}.crt"
echo -e "\n   Halten Sie das Passwort des Root-Zertifikates bereit\n   und bestaetigen Sie die Rueckfragen mit 'y'"
echo -e "\n   Druecken Sie 'Enter' zum Fortfahren"; read
openssl ca -config $CNF -in ${ZERTNAME}.req -out newcerts/${ZERTNAME}.crt -extensions server -notext 

# Zertifikat ausgeben
openssl x509 -in ./newcerts/${ZERTNAME}.crt -noout -text
echo -e "\nDruecken Sie 'Enter' zum Fortfahren"; read

#echo -e "\n...konvertiere das Zertifikat in: ${ZERTNAME}-x509cert.der"
#openssl x509 -in ./newcerts/${ZERTNAME}.crt -outform der -out ${ZERTNAME}-x509cert.der

# wenn Sie keine PKCS#12-Dateien verwenden wollen kommentieren Sie die folgenden Zeilen einfach aus
echo -e "\n...fasse das Zertifikat und den Schluessel in ${ZERTNAME}.p12 zusammen"
echo -e "\n   Sie werden zum Verschluesseln nach einem Passwort gefragt"
echo -e "\nDruecken Sie 'Enter' zum Fortfahren"; read

openssl pkcs12 -export -in ./newcerts/${ZERTNAME}.crt -inkey private/${ZERTNAME}.key -certfile ca.crt -out p12/${ZERTNAME}.p12
